<?

if (!is_local_user()) {
  
   include  "./lib/error.inc";
   Error($ds,$LANG['access_denied']);
}

if (!$res = @ldap_read($ds,$dn, "objectclass=*")){
   include  "./lib/error.inc";
   ldapError($ds, ldap_errno($ds));
}

$entry = @ldap_get_entries($ds,$res);
$baseEntry = $entry[0];

$name = getDisplayName($dn,$baseEntry,$language);

if ($language == 'pl') $map = $map_pl;
else $map = $map_en;

$header = $attrs = $attrsNames = $rule = $sortAttr = $resporttype = 0;

if (isset($_GET['header']) && $_GET['header'] )  $header   = $_GET['header'];
if (isset($_GET['Att']) && $_GET['Att'] )  $attrs  = $_GET['Att'];
else $Error = $LANG['report_error']; 

if (isset($_GET['AttName']) && $_GET['AttName'] ) $attrsNames   = $_GET['AttName'];
if (isset($_GET['rule']) && $_GET['rule'] ) $rule = $_GET['rule'];
if (isset($_GET['sorting']) && $_GET['sorting'] ) $sortAttr = $_GET['sorting'];
if (isset($_GET['reporttype']) && $_GET['reporttype'] ) $reporttype = $_GET['reporttype'];

$Sort = array();

if (!$Error){

    # set attributes for ldap_search 
    $searchAttrs = array($sortAttr);

    foreach ($attrs as $attr => $val) {
       array_push($searchAttrs, $attr);
    }

   # set search filter
   $rule[2] = trim($rule[2]);

   if (isset($rule[2]) && $rule[2]){

       $value = iconv("ISO-8859-2", "UTF-8", $rule[2]);

       $addfilter = 0; 
       switch ($rule[1]) {

           case "is":
              $addfilter = "(". $rule[0] ."=". $value. ")";
              break;

           case "contain":
                $addfilter = "(". $rule[0] ."=*". $value. "*)";
                break;

           case "start":
                $addfilter = "(". $rule[0] ."=". $value. "*)";
                break;

           case "end":
                $addfilter = "(". $rule[0] ."=*". $value. ")";
           }
   array_push($searchAttrs, $rule[0]);   
   }

   if (!in_array("displayname", $searchAttrs)) array_push($searchAttrs, "displayname");
   
   $filter = "";
   if ($reporttype == "unit") $filter = "objectclass=organizationalunit";
   else $filter = "objectclass=person";

   if ($addfilter) $filter = "(&".$addfilter . "(" . $filter . "))";
    
    if ($res = @ldap_search($ds,$dn,$filter,$searchAttrs) ) {
   
      $Result = array();
      $entries = @ldap_get_entries($ds,$res);

      for ($i=0; $i<$entries['count']; $i++) {  

         $Result[$i] = array();

         if ($sortAttr == 'sn') $Sort[$i] = getSurname($entries[$i],$language);
         else {
            $tmp = $sortAttr . ";lang-" . $language;
            $Sort[$i] = " ";  
            if ($entries[$i][$tmp]) $Sort[$i] = iconv("UTF-8","ISO-8859-2",$entries[$i][$tmp][0]);
            else{
               $Sort[$i] = iconv("UTF-8","ISO-8859-2",$entries[$i][$sortAttr][0]);
               if ($language != 'pl') {
                  $Sort[$i] = strtr($Sort[$i],"ʣӦ󶼿", "ACELNOSZZacelnoszz");
               }
            }
         }
         $j=0;
         foreach ($attrs as $att => $v){

            $tmp = $att . ";lang-" . $language;
            $valtmp = 0;
            if (isset($entries[$i][$tmp]) || ($entries[$i][$att])) {

               if ($att == "sn"){
                  $Result[$i][$j] = getSurname($entries[$i],$language);
               }
               elseif ($att == "telephonenumber"){
 
                  for($k=0; $k<$entries[$i][$att]["count"]; $k++){

                     $newvaltmp = iconv("UTF-8","ISO-8859-2",$entries[$i][$att][$k]);

                     if (preg_match("/^\s*\+48(\s|-)*$area_code(\s|-)*(.*)$/", $newvaltmp, $matches)){
                        $newvaltmp = $matches[3];
                     }
                     elseif(preg_match("/^\s*\+48(\s|-)*(.*)$/", $newvaltmp, $matches)) {
                         $newvaltmp = $matches[2];
                     }
                     elseif (preg_match("/^\s*$area_code(\s+|-)(.*)$/", $newvaltmp, $matches)) { 
                        $newvaltmp = $matches[2];
                     }
                     
                     if (preg_match("/^\s*(\d{3})(\s|-)*(\d{2})(\s|-)*(\d{2})\s*$/", $newvaltmp, $matches)){
                        $newvaltmp = $matches[1] . "-". $matches[3] ."-". $matches[5];
                    }
 
                    if ($valtmp) $valtmp.="&nbsp;<br>&nbsp;" . $newvaltmp;
                    else $valtmp = $newvaltmp;
                 }
                 $Result[$i][$j] = $valtmp;
              }
              elseif ($entries[$i][$tmp]) {
                $valtmp = iconv("UTF-8","ISO-8859-2",$entries[$i][$tmp][0]);
                $Result[$i][$j] = $valtmp;
              }
              else{
                 $valtmp = 0;
                 if ($entries[$i][$att]) {
                    $valtmp = iconv("UTF-8","ISO-8859-2",$entries[$i][$att][0]);
                 }
                 $Result[$i][$j] = $valtmp;
                 if ($language != 'pl') {
                    $Result[$i][$j] = strtr($valtmp,"ʣӦ󶼿", "ACELNOSZZacelnoszz");
                 }
             } 
          }
          else $Result[$i][$j] = "&nbsp;";
          $j++;
        } 
    }
    }
    else {
      include  "./lib/error.inc";
      ldapError($ds, ldap_errno($ds));
    }
   if (count($Sort)) uasort($Sort,"sortPL");
   ?>

   <html>
   <head>
   <title><?= $header? $header : $name ?></title>
   <meta http-equiv="content-type" content="text/html; charset=ISO-8859-2">
   <body marginwidth="0" marginheight="3" leftmargin="0" topmargin="3">
   <div align="center">
   <font face="Arial"><b><?= $name ?></b></font><br><br>
   <? if($header) echo "<font size=\"-1\" face=\"Arial\"><b>" . $header. "</b></font><br><br>"; ?>
   <table border="1" cellpadding="2" cellspacing="0">

   <?php
       echo "<tr>";
       echo "<th><font face=\"Arial\" size=\"-1\">".$LANG['no.']."</font></th>";
       $numcol = 1;
       foreach ($attrs as $attr => $val) {
       if (isset($attrsNames[$attr]) && $attrsNames[$attr]) {
          $value = $attrsNames[$attr];
          } 
       else {
          $value = $map[$attr];
          } 
       echo "<th><font face=\"Arial\" size=\"-1\">&nbsp;". $value . "&nbsp;</font></th>\n";

       # find column name to center (ex. roomnumber)
       if ($attr == "roomnumber" || $attr == "telephonenumber") $centernum[$numcol] = 1; 
       $numcol++;

       }
       echo "</tr>";

       $i=1;
       foreach ($Sort as $key => $val) {
          echo "<tr>";       
          echo "<td valign=\"middle\" align=\"center\"><font size=\"-1\" face=\"Arial\"> ". $i++ ." </font></td>";

          $numcol = 1;
          foreach ($Result[$key] as $value){
             if ($centernum[$numcol] == 1) $al = "center";
             else $al = "left";
             echo "<td valign=\"middle\" align=\"".$al."\"><font size=\"-1\" face=\"Arial\">&nbsp;" . $value ."&nbsp;</font></td>";
             $numcol++; 
          }
          echo "</tr>\n";
       }
   ?>
   </table>
   </div>
   </body>
   </html>
 
   <?php

}

else {
     include  ("./lib/error.inc");
     Error($ds, $Error); 
}

?>

