<?php
session_start(); 

include ('./config.php');
include ('./lib/general.inc');

$language = $default_language;
getParameters();

if (isset($_GET['newbase']) && $_GET['newbase']){
  $basedn_iso = urldecode($_GET['newbase']);
  $basedn = iconv("ISO-8859-2", "UTF-8", $basedn_iso);
  $_SESSION['treebase'] = $basedn_iso;
}

if (isset($_SESSION['lang']) && $_SESSION['lang']) {
   $language = $_SESSION['lang'];
   if (strcmp($_SESSION['lang'],$_SESSION['treelang']) !=0) {
      $_SESSION['treelang'] = $_SESSION['lang'];
      $_SESSION['cachedData'] = array();
   }
}
else {
   $_SESSION['treelang'] = $language;
}

include_once ("./lang/".$language.".php");

# set action on the bases of actionID 
$action = $Action[$_GET['actionID']];

if (isset($_SESSION['cachedData']['base']) && isset($_SESSION['treebase'])) {
   if (strcasecmp($_SESSION['treebase'],$_SESSION['cachedData']['base']) != 0){
       $_SESSION['cachedData'] = array();
   }
   $basedn_iso = $_SESSION['treebase'];
   $basedn = iconv("ISO-8859-2", "UTF-8", $basedn_iso);
}
elseif ($_SESSION['treebase']) {
   $_SESSION['cachedData'] = array();
   $basedn_iso = $_SESSION['treebase'];
   $basedn = iconv("ISO-8859-2", "UTF-8",$basedn_iso);
}
else {
   $_SESSION['treebase'] = $basedn_iso;  
}

# set action on the bases of actionID
if ($action == "EXPAND FOLDER"){   
   $Exp = urldecode($_GET['dn']);
   $selected = $Exp;
}
elseif ($action == "COLLAPSE FOLDER"){

    $dn = urldecode($_GET['dn']);
    $rdns = explodeDN ($dn,0);
    $rdn = $rdns[0];
    $Exp = str_replace($rdn,"", $dn);      
    $selected = $dn;
}
elseif ($action == "EXPAND DISPLAY"){
   $Exp = urldecode($_GET['dn']);
   $selected = $Exp;
?>

<script language="JavaScript" type="text/javascript">
<!--
parent.frames[1].location = "entry.php?actionID=<?= $ActionID['DISPLAY ENTRY'] ?>&dn=<?= urlencode($Exp) ?>";
//-->
</script>

<?php
}

elseif ($action == "COLLAPSE ALL"){
   unset($Exp);
?>
   <script language="JavaScript" type="text/javascript">
   <!--
   parent.frames[1].location = "entry.php?actionID=<?= $ActionID['DISPLAY ENTRY'] ?>";
   //-->
   </script>

<?php
}
elseif($action == "LOCALITY"){
   $Exp = urldecode($_GET['dn']);
   $selected = $Exp;
}

$init = 0;
if (isset($_SESSION['cachedData']['basename'])) {
   $name = $_SESSION['cachedData']['basename'];
}
else {
   if (!$init){
      ldap_init();
      $init = 1; 
   }
   $basedn_iso = iconv("UTF-8","ISO-8859-2", $basedn);
   if ($res = @ldap_read($ds,$basedn,"objectclass=*")){

      $entry = @ldap_get_entries($ds,$res);
      $baseEntry = $entry[0];
      $name = getDisplayName($basedn,$baseEntry,$language);
   }
   else {
      $_SESSION = array();
      include  "./lib/error.inc";
      ldapError($ds,ldap_errno($ds));
   }
   if (!$name) {
      $baserdns = explodeDN($basedn_iso,0);
      $name = $baserdns[0];
      for ($i=1; $i<count($baserdns); $i++) {
         $name .= ", ". $baserdns[$i];
      }
   }

   $_SESSION['cachedData']['basename'] = $name;
   $_SESSION['cachedData']['base'] =  $basedn_iso;
}

require ('./common_header.php');
?>

<table border="0" width="100%" cellpadding="2">
<tr><td></td></tr>
<tr><td width="100%">
<font face="Arial"><a href="tree.php?actionID=<?=$ActionID['COLLAPSE ALL'] ?>" class="tree-head" onmouseout="window.status='';" onmouseover="window.status='<?= $name ?>'; return true;">
<b><? echo $name; ?></b></a></font>
</td></tr>

<?php

include ('./lib/tree.inc'); 
showSubtree ($ds, $basedn, 0);
echo "\n</table>\n";

@ldap_close($ds);


function showSubtree($ds, $dn, $level){

  global $ActionID;
  global $Exp;
  global $init;
  global $ds;
  global $language;
  global $selected; 

  $Data = array();
  $cachedDN = $dn;
  $cached = 0;
 
  if (isset($_SESSION['cachedData'][$cachedDN])) {
      $Data = $_SESSION['cachedData'][$dn];
      $cached = 1;
  }
  else {
   if (!$init) {
      ldap_init();
      $init = 1;
   }
  
   # search subtree
   $res = @ldap_list($ds, $dn, $filter="objectclass=*");
   $entries = @ldap_get_entries($ds,$res);
   
   $dnufn = ldap_dn2ufn(iconv("UTF-8","ISO-8859-2",$dn));   

   if ($entries["count"] > 0){
 
      $Role_Other = array();
      $Person = array();
      $Other = array();
      $Prodziekani = array();
      $Dziekanat = array();
      $Sekretariat = array();

      # it has subtree, insert entries into new array and sort  
      for ($i=0; $i<$entries["count"]; $i++){

          $other=1;
          $dn = $entries[$i]["dn"];
          $name_iso = getDisplayName($dn,$entries[$i],$language);

          
          if (is_Unit($entries[$i]['objectclass'])) {
              $Unit[$dn] = 1;
              $rdns = explodeDN(iconv("UTF-8","ISO-8859-2",$dn),0);
              $rdn = $rdns[0]; 

              if (preg_match("/^W[l]adze/i", $rdn)){
                 $Wladze[$dn] = $name_iso;
                 $other=0;
              }
              elseif ($rdn == "Prodziekani"){
                 $Prodziekani[$dn] = $name_iso;
                 $other=0; 
              }
              elseif ($rdn == "Dziekanat"){
                 $Dziekanat[$dn] = $name_iso;
                 $other=0;
              }
              elseif (preg_match("/^Sekretariat/i", $rdn)){
                 $Sekretariat[$dn] = $name_iso;
                 $other=0;
              }
          }

          # insert names into arrays for sorting
          if (is_Role($entries[$i]['objectclass'])) {
              $Role[$dn] = 1;
              $rdns = explodeDN(iconv("UTF-8","ISO-8859-2",$dn),0);
              $rdn = $rdns[0];

              if (preg_match("/^(J\.\sM\.\s)*Rektor/i", $rdn)){
                 $Rektor[$dn] = $name_iso;
              }
              elseif(stristr($rdn,"Prorektor")){
                 $Prorektorzy[$dn] = $name_iso;
              }
              else{ 
                 $Role_Other[$dn] = $name_iso;
              }

          }             
          else {
             # People are sorted by surname 
             if (is_Person($entries[$i]['objectclass'])) {
                $Person[$dn] = getSurname($entries[$i],$language);
                if ($language != 'pl') {
                   $Person[$dn] = strtr($Person[$dn],"ʣӦ󶼿", "ACELNOSZZacelnoszz");
                } 
                $Person[$dn] .= $name_iso;
                }
             else {
                if($other) {
                   $Other[$dn] = $name_iso;
                }
             }
          }

          # insert each dn and displayed names into array
          $Entries[$dn] = $name_iso;
      }

  
      if (count($Rektor)) uasort ($Rektor,"sortPL");
      if (count($Prorektorzy)) uasort ($Prorektorzy,"sortPL");
      if (count($Role_Other)) uasort ($Role_Other,"sortPL");
      if (count($Wladze)) uasort ($Wladze,"sortPL");
      if (count($Sekretariat)) uasort ($Sekretariat,"sortPL");
      if (count($Dziekanat)) uasort ($Dziekanat,"sortPL");

      if (count($Person)) uasort($Person,"sortPL");

      $Role_Person = array_merge($Rektor, $Prorektorzy, $Role_Other,$Person);

      if (count($Other)) uasort ($Other,"sortPL");

      $AllData = array_merge($Role_Person,$Wladze,$Prodziekani,$Dziekanat,$Sekretariat,$Other);

      foreach ($AllData as $key => $val) {
          $Data[$key] = $Entries[$key];
          $_SESSION['cachedData'][$cachedDN][$key] = $Data[$key];
          if ($Unit[$key]) $_SESSION['cachedData']['unit'][$key] = 1;
          if ($Role[$key]) $_SESSION['cachedData']['role'][$key] = 1;
      }
   
      }
    }
      # dispaly subtree
      while ($item = each($Data)) {


         $dn = $item['key'];
         $name = $item['value'];
         $name = htmlspecialchars($name);         
 
         $dn_iso = iconv("UTF-8","ISO-8859-2", $dn);
         $unit = 0;
         $role = 0;
         if ($cached) {
           if ($_SESSION['cachedData']['unit'][$dn]) $unit = 1;
           if ($_SESSION['cachedData']['role'][$dn]) $role = 1;
         }
         else {
            if ($Unit[$dn]) $unit = 1;
            if ($Role[$dn]) $role = 1;
         }       
                   
         # check if expand this subtree
         if (checkExpand($dn_iso)){  

            if ($unit) {
               echo "<tr><td><table border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr><td align=\"right\" valign=\"top\">",
                    "<nobr><img height=1 width=". ($level)*18 . " src = \"images/spacer.gif\" >";
                    showIcons($name, $dn_iso, "open", "minus", 11);
                    showSubtree($ds, $dn, $level+1);
               }
            else { 
               #person, display person icon 
               echo "<tr><td><table border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr><td align=\"right\" valign=\"top\">",
                    "<img height=1 width=". ($level)*18 . " src = \"images/spacer.gif\" >";
               if ($role) echo "<img border=0 src=\"images/person_role.gif\"></td>";
               else echo "<img border=0 src=\"images/person.gif\"></td>";
               echo "<td><font size=\"-1\" face=\"Arial\"><b>";
               $select = 0;
               if (strcmp($selected,$dn_iso) == 0 ){
                  echo "<a name=\"select\">";
                  $select = 1;
               }

               echo "<a target=\"right\" href=\"./entry.php?", "actionID=", $ActionID['DISPLAY ENTRY'], "&dn=", urlencode($dn_iso)."\" class=\"",$select ? "tree-select" : "tree","\" onmouseout=\"window.status='';\" onmouseover=\"window.status='".$name."'; return true;\">",
                    $name . "</a></b></font></td></tr></table></td></tr>\n";
               }
         }

         else {
            # don't expand 
            echo "<tr><td valign=\"top\"><table border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr><td align=\"right\" valign=\"top\">";

                if ($unit) {

                   echo "<nobr><img height=1 width=". ($level)*18 . " src = \"images/spacer.gif\" >";
                   showIcons(NULL, $dn_iso, "close", "plus", 10);
                   $entry_action = $ActionID['EXPAND DISPLAY'];
                   $entry_url = "./tree.php?actionID=". $entry_action ."&dn=". urlencode($dn_iso) ."#select"; 
                   $target = "left";
                }
                else {
                   # no children, display person icon
                   echo "<img height=1 width= ". ($level)*18 . " src = \"images/spacer.gif\">";
                   if ($role) echo "<img border=0 src=\"images/person_role.gif\">";
                   else echo "<img border=0 src=\"images/person.gif\">";
                   $entry_action = $ActionID['DISPLAY ENTRY'];
                   $entry_url = "./entry.php?actionID=". $entry_action ."&dn=". urlencode($dn_iso);
                   $target="right";
                }
            echo "</td><td>",
                 "<font size=\"-1\" face=\"Arial\"><b><a target=\"".$target."\" href=\"".$entry_url. "\"",
                 " class=\"tree\" onmouseout=\"window.status='';\" onmouseover=\"window.status='". $name ."'; return true;\">",
                 $name . "</a></b></font></td></tr></table></td></tr>\n"; 
         }
      } 
}

require ('./common_footer.php');
?>
